<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import _ from "lodash";
import { apiErrorHandler } from "~/utils/apiHanlers";
import { api } from "~/common/constaint";
var momentz = require("moment-timezone");
var moment = require("moment");
@Component({})
export default class AdminOrderComponent extends Vue {
  get listIds() {
    return this.$store.state.adminOrder.listIds;
  }

  set listIds(value: string[]) {
    this.$store.commit("adminOrder/setListIds", value);
  }

  tab = 0;
  limitItems = [5, , 10, , 15, , 20, , 25, , 30, , 35, , 40];

  json_fields = {
    CouponCode: "couponCode",
    OrderCode: "orderCode",
    Payment: "payment",
    Email: "email",
    FirstName: "firstName",
    LastName: "lastName",
    Address: "address",
    Apartment: "apartment",
    CompanyName: "companyName",
    ZipCode: "zipCode",
    City: "city",
    State: "state",
    Country: "country",
    PhoneNumber: "phoneNumber",
  };
  json_data = [];
  json_meta = [
    [
      {
        key: "charset",
        value: "utf-8",
      },
    ],
  ];

  loading = false;
  //   loadingTable = false;
  selectedAll = false;

  listFilter = [
    { name: "All", value: "all" },
    { name: "Preparing", value: 1 },
    { name: "Delivering", value: 2 },
    { name: "Done", value: 3 },
  ];
  filter = "all";

  listStatus = [
    { name: "Preparing", value: 1 },
    { name: "Delivering", value: 2 },
    { name: "Done", value: 3 },
  ];

  listAllOrder = [];

  settings = {};

  get loadingTable() {
    return this.$store.state.adminOrder.loadingTable;
  }

  //   set loadingTable(value: boolean) {
  //     this.$store.commit("adminOrder/setLoadingTable", value);
  //   }
  mounted() {
    this.onGetListOrder();
  }
  formatDate(date: string) {
    return this.$utils.formatDateCreatedAt(date);
    // return this.$utils.formatDate(date, this.settings);
  }

  fetchData() {
    if (!this.listIds.length) {
      return this.$pushNotification.error("Please select order list");
    }
    this.json_data = [];
    for (let id of this.listIds) {
      const findOrder: any = this.listAllOrder.find(
        (order: any) => order._id === id
      );
      if (findOrder && findOrder.shippingAddress) {
        //@ts-ignore
        this.json_data.push({
          ...findOrder.shippingAddress,
          //@ts-ignore
          orderCode: findOrder.orderCode,
          //@ts-ignore
          payment: findOrder.payment,
        });
      }
    }
  }

  handleExportTxt() {
    if (!this.listIds.length) {
      return this.$pushNotification.error("Please select order list");
    }
    let finalText = ``;
    this.json_data = [];
    for (let id of this.listIds) {
      const findOrder: any = this.listAllOrder.find(
        (order: any) => order._id === id
      );
      if (findOrder && findOrder.shippingAddress) {
        finalText += `CouponCode: ${findOrder.couponCode || ""} | OrderCode: ${
          findOrder.orderCode || ""
        } | Payment: ${findOrder.payment || ""} | Email: ${
          findOrder.shippingAddress.email || ""
        } | FirstName: ${
          findOrder.shippingAddress.firstName || ""
        } | LastName: ${findOrder.shippingAddress.lastName || ""} | Address: ${
          findOrder.shippingAddress.address || ""
        } | Apartment: ${
          findOrder.shippingAddress.apartment || ""
        } | CompanyName: ${
          findOrder.shippingAddress.companyName || ""
        } | ZipCode: ${findOrder.shippingAddress.zipCode || ""} | City: ${
          findOrder.shippingAddress.city || ""
        } | State: ${findOrder.shippingAddress.state || ""} | Country: ${
          findOrder.shippingAddress.country || ""
        } | PhoneNumber: ${findOrder.shippingAddress.phoneNumber}`;
      }
    }
    this.handleExportFile(`export-order`, finalText);
  }

  handleExportFile(name: string, content: string) {
    var FileSaver = require("file-saver");
    var blob = new Blob([`${content}`], {
      type: "text/plain;charset=utf-8",
    });
    FileSaver.saveAs(blob, name);
  }

  async onGetListOrder() {
    this.listIds = [];
    try {
      await this.$store.dispatch("adminOrder/onGetListOrder", {
        ctx: this,
      });
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onChangeStatus(order: any, status: number) {
    try {
      //@ts-ignore
      await this.$api.order.updateOrder(order._id, parseInt(status));
      this.$pushNotification.success("Updated status successfully");
      this.onGetListOrder();
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  convertImage(url: string) {
    return `${api}/${url}`;
  }

  onRedirectPage() {
    this.$store.commit("adminOrder/setPage", this.page);
    this.onGetListOrder();
  }

  get configPage() {
    return this.$store.state.adminOrder.config.page;
  }

  set configPage(value) {
    this.$store.commit("adminOrder/setPage", value);
  }

  get configLimit() {
    return this.$store.state.adminOrder.config.limit;
  }

  set configLimit(value) {
    this.$store.commit("adminOrder/setLimit", value);
  }

  get configSearch() {
    return this.$store.state.adminOrder.config.page;
  }

  set configSearch(value) {
    this.$store.commit("adminOrder/setSearch", value);
  }

  get config() {
    return this.$store.state.adminOrder.config;
  }

  get listOrder() {
    return this.$store.state.adminOrder.listOrder;
  }

  get totalPage() {
    return this.$store.state.adminOrder.totalPage;
  }

  get page() {
    return this.$store.state.adminOrder.page;
  }

  set page(value: number) {
    this.$store.commit("adminOrder/setPageRedirect", value);
  }

  @Watch("selectedAll")
  async onSelectAllChanged(value: string, oldValue: string) {
    if (value) {
      const listIds = [...this.listIds];
      //@ts-ignore
      const selectedCurrentOrder = this.listOrder
        //@ts-ignore
        .map((order) => order._id)
        //@ts-ignore
        .filter((id) => !listIds.includes(id));
      //@ts-ignore
      this.listIds = [...listIds, ...selectedCurrentOrder];
    } else {
      //@ts-ignore
      const selectedCurrentOrder = this.listOrder
        //@ts-ignore
        .map((order) => order._id);
      this.listIds = this.listIds.filter(
        (c) => !selectedCurrentOrder.includes(c)
      );
    }
  }

  @Watch("config.search")
  changedSearch(val: string) {
    if (!val) {
      this.onGetListOrder();
    }
  }

  @Watch("config.page")
  changedPage() {
    this.onGetListOrder();
  }

  @Watch("filter")
  changedFilter() {
    this.onGetListOrder();
  }

  @Watch("listIds")
  changedListIds(value: string[]) {
    this.$emit("update:listIds", value);
  }
}
</script>

<style>
.list-menu {
  width: 100%;
}

.list-menu:hover {
  background-color: #ecf0f1;
}

.list-menu--active {
  background-color: #076ce3;
  padding: 4px 8px;
}
</style>
